local addonName, ns = ...
local _G = _G
local setfenv = _G.setfenv
local addon = ns.addon
setfenv(1, addon)

local type = _G.type
local pairs = _G.pairs

function ns.deepCopy(arg)
    if type(arg) == 'table' then
        local result = {}
        for k,v in pairs(arg) do
            result[k] = ns.deepCopy(v)
        end
        return result
    else
        return arg
    end
end

function addon:newTemplate(oldTemplate)
    return ns.deepCopy(oldTemplate)
end