local _, ns = ...

local _G = _G
ns.Locales = {}
local Locales = ns.Locales
local setfenv = _G.setfenv
setfenv(1, Locales)

local pairs = _G.pairs
local string = _G.string

local template = {}

function template:formatNumber(number)
    local first = string.sub(number, 1, 1)
    local middle = string.sub(number, 2)
    return first .. string.reverse(middle):gsub('(%d%d%d)','%1' .. self.digitSeperator):reverse()
end

local function copy(table)
    local result = {}
    for k,v in pairs(table) do
        result[k]=v
    end
    return result
end

Locales.userLocale = copy(template)

Locales.userLocale.digitSeperator = '.'

function Locales:getUserLocale()
    return self.userLocale
end